%define anolis_release 1
# No, please don't break the linker.  Thanks.
%undefine _auto_set_build_flags

Name: gnu-efi
Epoch: 1
Version: 3.0.15
Release: %{anolis_release}%{?dist}
Summary: Development Libraries and headers for EFI
License: BSD 
URL: https://sourceforge.net/projects/gnu-efi/

Source0: https://sourceforge.net/projects/gnu-efi/files/gnu-efi-%{version}.tar.bz2

ExclusiveArch: %{efi}
BuildRequires: binutils
BuildRequires: efi-srpm-macros >= 5
BuildRequires: gcc
BuildRequires: git-core
BuildRequires: make

Obsoletes: %{name}-compat < 3.0.11

# dammit, rpmlint, shut up.
%define lib %{nil}lib%{nil}

%define debug_package %{nil}

%undefine __brp_strip_static_archive
%global __brp_strip_static_archive find '%{buildroot}' -name '*.a' -print -exec %{__strip} -gDp {} \\;

%description
This package contains development headers and libraries for developing
applications that run under EFI (Extensible Firmware Interface).

%package devel
Summary: Development Libraries and headers for EFI
Obsoletes: gnu-efi < 1:3.0.2
Requires: gnu-efi = %{epoch}:%{version}-%{release}

%description devel
This package contains development headers and libraries for developing
applications that run under EFI (Extensible Firmware Interface).

%package utils
Summary: Utilities for EFI systems

%description utils
This package contains utilities for debugging and developing EFI systems.

%package doc
Summary:        Doc files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description doc
Doc files for %{name}

%prep
%autosetup -p1

%build
%undefine _hardened_ldflags
# fix warning "ld: warning: t.so has a LOAD segment with RWX permissions"
export LDFLAGS="$LDFLAGS --no-warn-rwx-segments"
# Package cannot build with %%{?_smp_mflags}.
make LIBDIR=%{_prefix}/lib
make apps
%if %{efi_has_alt_arch}
  setarch linux32 -B make ARCH=%{efi_alt_arch} PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib
  setarch linux32 -B make ARCH=%{efi_alt_arch} PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib apps
%endif

%install
mkdir -p %{buildroot}%{_prefix}/lib/gnuefi/%{efi_arch}
make PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib INSTALLROOT=%{buildroot} install
mv %{buildroot}%{_prefix}/lib/*.{lds,o,a} %{buildroot}%{_prefix}/lib/gnuefi/%{efi_arch}

mkdir -p %{buildroot}/%{efi_esp_dir}/%{efi_arch}
mv %{_target_cpu}/apps/{route80h.efi,modelist.efi} %{buildroot}%{efi_esp_dir}/%{efi_arch}/

%if %{efi_has_alt_arch}
  setarch linux32 -B make PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib INSTALLROOT=%{buildroot} ARCH=%{efi_alt_arch} install
  mkdir -p %{buildroot}%{efi_esp_dir}/%{efi_alt_arch}
  mv %{efi_alt_arch}/apps/{route80h.efi,modelist.efi} %{buildroot}%{efi_esp_dir}/%{efi_alt_arch}/
  mkdir -p %{buildroot}%{_prefix}/lib/gnuefi/%{efi_alt_arch}
  mv %{buildroot}%{_prefix}/lib/*.{lds,o,a} %{buildroot}%{_prefix}/lib/gnuefi/%{efi_alt_arch}
%endif

%files
%dir %{_prefix}/lib/gnuefi/
%{_prefix}/lib/gnuefi/*/

%files devel
%{_includedir}/efi

%files utils
%dir %attr(0700,root,root) %{efi_esp_dir}/%{efi_arch}/
%attr(0700,root,root) %{efi_esp_dir}/%{efi_arch}/*.efi
%if %{efi_has_alt_arch}
  %dir %attr(0700,root,root) %{efi_esp_dir}/%{efi_alt_arch}/
  %attr(0700,root,root) %{efi_esp_dir}/%{efi_alt_arch}/*.efi
%endif

%files doc
%doc README.*

%changelog
* Sat Mar 25 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 3.0.15-1
- init from upstream
